﻿using System;
using System.Runtime.CompilerServices;

namespace TestProject
{
    /// <summary>
    /// 호출하기 비동기 상태 머신
    /// </summary>
    public class CallAsyncStateMachine : IAsyncStateMachine
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region Field

        /// <summary>
        /// 프로그램
        /// </summary>
        public Program Program;

        /// <summary>
        /// 비동기 태스크 메소드 빌더
        /// </summary>
        public AsyncTaskMethodBuilder Builder;

        /// <summary>
        /// 상태
        /// </summary>
        public int State;

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 태스크 대기자
        /// </summary>
        private TaskAwaiter<string> taskAwaiter;

        /// <summary>
        /// 현재 시간
        /// </summary>
        private string currentTime;

        /// <summary>
        /// 텍스트
        /// </summary>
        private string text;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region (IAsyncStateMachine) 다음으로 이동하기 - MoveNext()

        /// <summary>
        /// 다음으로 이동하기
        /// </summary>
        public void MoveNext()
        {
            try
            {
                TaskAwaiter<string> taskAwaiter;

                switch(State)
                {
                    case 0 :

                        taskAwaiter = this.taskAwaiter;

                        this.taskAwaiter = new TaskAwaiter<string>();

                        State = -1;

                        break;

                    default:

                        this.currentTime = DateTime.Now.ToString();

                        taskAwaiter = Program.GetTextAsync().GetAwaiter();

                        if(taskAwaiter.IsCompleted == false)
                        {
                            State = 0;

                            this.taskAwaiter = taskAwaiter;

                            CallAsyncStateMachine callAsyncStateMachine = this;

                            Builder.AwaitUnsafeOnCompleted(ref taskAwaiter, ref callAsyncStateMachine);

                            return;
                        }

                        break;
                }

                this.text = taskAwaiter.GetResult();

                Console.WriteLine(this.currentTime + " : " + this.text);
            }
            catch(Exception exception)
            {
                State = -2;

                Builder.SetException(exception);

                return;
            }

            State = -2;

            Builder.SetResult();
        }

        #endregion
        #region (IAsyncStateMachine) 상태 머신 설정하기 - SetStateMachine(stateMachine)

        /// <summary>
        /// 상태 머신 설정하기
        /// </summary>
        /// <param name="asyncStateMachine">비동기 상태 머신</param>
        public void SetStateMachine(IAsyncStateMachine asyncStateMachine)
        {
        }

        #endregion
    }
}