﻿using System;
using System.Runtime.CompilerServices;
using System.Threading.Tasks;

namespace TestProject
{
    /// <summary>
    /// 프로그램
    /// </summary>
    public class Program
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region 프로그램 시작하기 - Main()

        /// <summary>
        /// 프로그램 시작하기
        /// </summary>
        private static void Main()
        {
            Console.Title = "IAsyncStateMachine 인터페이스 : 비동기 처리하기";

            Program program = new Program();

            Task task = program.CallAsync();

            task.GetAwaiter().GetResult();
        }

        #endregion

        #region 비동기 텍스트 구하기 - GetStringAsync()

        /// <summary>
        /// 비동기 텍스트 구하기
        /// </summary>
        /// <returns>문자열 태스크</returns>
        public Task<string> GetTextAsync()
        {
            GetTextAsyncStateMachine asyncStateMachine = new GetTextAsyncStateMachine
            {
                Program = this,
                Builder = AsyncTaskMethodBuilder<string>.Create(),
                State   = -1
            };

            asyncStateMachine.Builder.Start(ref asyncStateMachine);

            return asyncStateMachine.Builder.Task;
        }

        #endregion
        #region 비동기 호출하기 - CallAsync()

        /// <summary>
        /// 비동기 호출하기
        /// </summary>
        /// <returns>태스크</returns>
        public Task CallAsync()
        {
            CallAsyncStateMachine asyncStateMachine = new CallAsyncStateMachine
            {
                Program = this,
                Builder = AsyncTaskMethodBuilder.Create(),
                State   = -1
            };

            asyncStateMachine.Builder.Start(ref asyncStateMachine);

            return asyncStateMachine.Builder.Task;
        }

        #endregion
    }
}